diff --git a/plugins/omelasticsearch/omelasticsearch.c b/plugins/omelasticsearch/omelasticsearch.c
index 5e54d3086c..1ba677be96 100644
--- a/plugins/omelasticsearch/omelasticsearch.c
+++ b/plugins/omelasticsearch/omelasticsearch.c
@@ -308,8 +308,7 @@ computeBaseUrl(char* serverParam, int defaultPort, sbool useHttps, uchar **baseU
 	else if (strcasestr(serverParam, SCHEME_HTTPS))
 		host = serverParam + strlen(SCHEME_HTTPS);
 	else
-		r = useHttps ?
-			es_addBuf(&urlBuf, SCHEME_HTTPS, sizeof(SCHEME_HTTPS)-1) : 
+		r = useHttps ? es_addBuf(&urlBuf, SCHEME_HTTPS, sizeof(SCHEME_HTTPS)-1) : 
 			es_addBuf(&urlBuf, SCHEME_HTTP, sizeof(SCHEME_HTTP)-1);
 
 	if (r == 0) r = es_addBuf(&urlBuf, serverParam, strlen(serverParam));
diff --git a/template.c b/template.c
index 929c495b7d..f30ff434a9 100644
--- a/template.c
+++ b/template.c
@@ -413,7 +413,7 @@ static void doEmergencyEscape(register uchar *p, int mode)
 	while(*p) {
 		if((mode == SQL_ESCAPE||mode == STDSQL_ESCAPE) && *p == '\'')
 			*p = '"';
-		else if((mode == JSON_ESCAPE) && *p == '"')
+		else if((mode == JSON_ESCAPE) &&  (*p == '"' || *p == '\\' ))
 			*p = '\'';
 		else if((mode == SQL_ESCAPE) && *p == '\\')
 			*p = '/';
@@ -467,7 +467,7 @@ doEscape(uchar **pp, rs_size_t *pLen, unsigned short *pbMustBeFreed, int mode)
 		for(p = *pp ; *p && *p != '\'' && *p != '\\' ; ++p)
 			;
 	else if(mode == JSON_ESCAPE)
-		for(p = *pp ; *p && *p != '"' ; ++p)
+		for(p = *pp ; *p &&  (*p != '"' || *p != '\\' ) ; ++p)
 			;
 	/* when we get out of the loop, we are either at the
 	 * string terminator or the first character to escape */
@@ -485,7 +485,7 @@ doEscape(uchar **pp, rs_size_t *pLen, unsigned short *pbMustBeFreed, int mode)
 		} else if((mode == SQL_ESCAPE) && *p == '\\') {
 			CHKiRet(cstrAppendChar(pStrB, '\\'));
 			iLen++;	/* reflect the extra character */
-		} else if((mode == JSON_ESCAPE) && *p == '"') {
+		} else if((mode == JSON_ESCAPE) &&  (*p == '"' || *p == '\\' )) {
 			CHKiRet(cstrAppendChar(pStrB, '\\'));
 			iLen++;	/* reflect the extra character */
 		}
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 572b922550..4acd09bccd 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -350,6 +350,7 @@ endif
 if ENABLE_ELASTICSEARCH_TESTS
 TESTS +=  \
 	es-basic.sh \
+	es-basic-server.sh \
 	es-basic-ha.sh \
 	es-basic-bulk.sh \
 	es-maxbytes-bulk.sh \
diff --git a/tests/es-basic-server.sh b/tests/es-basic-server.sh
new file mode 100755
index 0000000000..0d20d6ce0f
--- /dev/null
+++ b/tests/es-basic-server.sh
@@ -0,0 +1,13 @@
+#!/bin/bash
+# This file is part of the rsyslog project, released under ASL 2.0
+echo ===============================================================================
+echo \[es-basic-server.sh\]: basic test for elasticsearch functionality with server 
+. $srcdir/diag.sh init
+. $srcdir/diag.sh es-init
+. $srcdir/diag.sh startup es-basic-server.conf
+. $srcdir/diag.sh injectmsg  0 10000
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown 
+. $srcdir/diag.sh es-getdata 10000
+. $srcdir/diag.sh seq-check  0 9999
+. $srcdir/diag.sh exit
diff --git a/tests/testsuites/es-basic-server.conf b/tests/testsuites/es-basic-server.conf
new file mode 100644
index 0000000000..ecb10684bf
--- /dev/null
+++ b/tests/testsuites/es-basic-server.conf
@@ -0,0 +1,10 @@
+$IncludeConfig diag-common.conf
+
+template(name="tpl" type="string"
+	 string="{\"msgnum\":\"%msg:F,58:2%\"}")
+
+module(load="../plugins/omelasticsearch/.libs/omelasticsearch")
+:msg, contains, "msgnum:" action(type="omelasticsearch"
+				 server="localhost" 
+				 template="tpl"
+				 searchIndex="rsyslog_testbench")
